//------------------------------------------- source code refer to (WSC) file.c
#ifndef _FILE_H_
#define _FILE_H_

#include "fxlib.h"

/* return a filename */
unsigned int SelectFile (char *filename);
void FileListfree() ;

// #define DEBUG
// if define DEBUG, the files are in SD card
// else the files are in storage memory

#ifdef DEBUG
#define ROOT "crd0"
#else
#define ROOT "fls0"
#endif

FONTCHARACTER *CharToFont( const char *cFileName, FONTCHARACTER *fFileName );
char *FontToChar( const FONTCHARACTER *fFileName, char *cFileName );

#endif

extern char FileListUpdate;
extern char StorageMode;		// 0:Storage memory   1:SD

#define FileCMD_Prog   10000
#define FileCMD_RUN    10001
#define FileCMD_DebugRUN    10002
#define FileCMD_EDIT   10003
#define FileCMD_NEW    10004
#define FileCMD_RENAME 10005
#define FileCMD_DEL    10006
#define FileCMD_COPY   10007
#define FileCMD_TEXT   10008
#define FileCMD_PASS   10009

char *loadFile( const char *name , int editMax);
int  storeFile( const char *name, unsigned char* codes, int size);
int LoadProgfile( char *name , int editsize) ;
int SaveG1M( char *filebase );
int SaveProgfile(int progNo );

int SavePicture( char *filebase, int pictNo );
char * LoadPicture( int pictNo );

int  RenameFile(char *name) ;
void DeleteFile(char *name) ;
void DeleteFileFav(char *sname) ;
int CopyFile( char *sname ) ;

void ConvertToText( char *sname );

int NewProg();
void CB_Local( char *SRC ) ;
void CB_ProgEntry( char *SRC ) ; //	Prog "..." into memory

void SaveFavorites();
void SaveConfig();
void LoadConfig();

int CB_IsExist( char *SRC ) ;	//	IsExist("TEST")		//  no exist: return 0     exist: return filesize
void CB_Save( char *SRC ) ; //	Save "TEST",Mat A[1,3]
void CB_Load( char *SRC ) ; //	Load ("TEST" [, Ptr])->Mat A[1,3] 

void Setfoldername16( char *folder16, char *sname ) ;
int CheckPassWord( char *filebase );	// 1:cancel  0:Ok  -1:no pass
void NewPassWord(char *name) ;

void PP_ReplaceCode( char *SRC );
int CheckSD();	// SD model  return : 1
